<?php

/**
 * @package Generic
 * @subpackage DumpIO
 *
 * @author: jijutm@saturn.in http://www.saturn.in
 * Got inspired by the Apache dump_io module, but was reluctant to restart the
 * webserver to start a dump window for doing forensic on our project.
 */
 

class phpDumpIO
{

    private $get;
    
    public function __construct(){
        $this->get = array();
    }

    public function __destruct(){
       $this->get['_OUTPUT'] = ob_get_contents();
       $this->writelog($this->get);
    }

    public function DumpIOInput($get = false){
        $dx = array("_GET", "_POST", "_SESSION", "_FILES");
        $d = array();
        foreach($dx as $x){
           global $$x;
           if(!empty($$x)){
              $d[$x] = $$x;
           }
        }   
        if($get == false)   
            $this->writelog($d);
        else
            $this->get = $d;    
    }

    public function DumpIOOutput(){
        ob_start();
    }

    public function DumpIOBoth(){
        $this->DumpIOInput(true);
        $this->DumpIOOutput();
    }

    private function writelog($d){
        $logfile = '/var/log/phpdumpio.log';
        $write = array(date("c"),$_SERVER['REMOTE_ADDR'],$_SERVER['REQUEST_URI'],base64_encode(serialize($d)), "\n");
        file_put_contents($logfile, join(' ', $write), FILE_APPEND);
    }
}

$tracedump = new phpDumpIO();
$tracedump->DumpIOBoth();
